﻿namespace RadSchedulerApp.Controllers
{

    using System.Collections.Generic;
    using System.Web.Http;
    using System.Web.Script.Serialization;

    using DatabaseProvider;

    using Telerik.Web.UI;

    public class SchedulerController : ApiController
    {
        private JavaScriptSerializer serializer;
        private EfSchedulerProvider provider;
        private WebServiceAppointmentController controller;

        public SchedulerController()
            : base()
        {
        }

        private JavaScriptSerializer JavaScriptSerializer
        {
            get
            {
                if (serializer == null)
                {
                    serializer = new JavaScriptSerializer();
                }

                return serializer;
            }
        }

        private EfSchedulerProvider Provider
        {
            get
            {
                if (this.provider == null)
                {
                    this.provider = new EfSchedulerProvider();
                }

                return this.provider;
            }
        }

        private WebServiceAppointmentController Controller
        {
            get
            {
                if (this.controller == null)
                {
                    this.controller = new WebServiceAppointmentController(Provider);
                }

                return this.controller;
            }
        }

        [HttpGet]
        public IEnumerable<AppointmentData> GetAppointments(string schedulerInfo)
        {
            return Controller.GetAppointments(JavaScriptSerializer.Deserialize<MySchedulerInfo>(schedulerInfo));
        }

        [HttpPost]
        public IEnumerable<AppointmentData> InsertAppointment(WebApiData data)
        {
            return Controller.InsertAppointment(data.SchedulerInfo, data.AppointmentData);
        }

        [HttpPut]
        public IEnumerable<AppointmentData> UpdateAppointment(WebApiData data)
        {

            return Controller.UpdateAppointment(data.SchedulerInfo, data.AppointmentData);
        }

        [HttpPost]
        public IEnumerable<AppointmentData> CreateRecurrenceException(WebApiData data)
        {
            return Controller.CreateRecurrenceException(data.SchedulerInfo, data.RecurrenceExceptionData);
        }

        [HttpDelete]
        public IEnumerable<AppointmentData> RemoveRecurrenceExceptions(WebApiData data)
        {
            return Controller.RemoveRecurrenceExceptions(data.SchedulerInfo, data.MasterAppointmentData);
        }

        [HttpDelete]
        public IEnumerable<AppointmentData> DeleteAppointment(WebApiData data)
        {
            return Controller.DeleteAppointment(data.SchedulerInfo, data.AppointmentData, data.DeleteSeries);
        }

        [HttpGet]
        public IEnumerable<ResourceData> GetResources(string schedulerInfo)
        {
            var o = new JavaScriptSerializer().Deserialize<MySchedulerInfo>(schedulerInfo);
            return Controller.GetResources(o);
        }
    }
}
